import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewEncapsulation, Input, Output, ViewChild, Pipe, NgModule } from '@angular/core';
import * as i1 from 'formbird-services';
import { FormbirdInjectorService, SearchService, FormbirdServicesModule } from 'formbird-services';
import * as i6 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i1$3 from '@angular/platform-browser';
import { BrowserModule } from '@angular/platform-browser';
import * as i9 from '@angular/material/autocomplete';
import { MatAutocompleteTrigger, MatAutocompleteModule } from '@angular/material/autocomplete';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i7 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i8 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { throwError, Subscription, Observable } from 'rxjs';
import * as Handlebars from 'handlebars';
import * as olControl from 'ol/control';
import * as olInteraction from 'ol/interaction';
import { defaults } from 'ol/interaction';
import * as olColor from 'ol/color';
import { asArray } from 'ol/color';
import * as olExtent from 'ol/extent';
import { boundingExtent } from 'ol/extent';
import Feature from 'ol/Feature';
import * as geom from 'ol/geom';
import * as proj from 'ol/proj';
import { transform } from 'ol/proj';
import Fill from 'ol/style/Fill';
import Stroke from 'ol/style/Stroke';
import Style from 'ol/style/Style';
import Circle from 'ol/style/Circle';
import Icon from 'ol/style/Icon';
import LineString from 'ol/geom/LineString';
import TileLayer from 'ol/layer/Tile';
import Map from 'ol/Map';
import OSM from 'ol/source/OSM';
import View from 'ol/View';
import Overlay from 'ol/Overlay';
import * as i1$1 from 'formbird-sc-shared';
import { SclUtilDateService } from 'formbird-sc-shared';
import { chunk, nth, isString, cloneDeep, isNumber } from 'lodash';
import { SharedConstants } from '@formbird/types';
import { UtilHttpStatus } from '@formbird/shared';
import * as moment from 'moment';
import { getDistance } from 'ol/sphere';
import Text from 'ol/style/Text';
import LayerVector from 'ol/layer/Vector';
import SourceVector from 'ol/source/Vector';
import Point from 'ol/geom/Point';
import Polygon, { circular } from 'ol/geom/Polygon';
import * as i1$2 from '@angular/common/http';
import { HttpParams, HttpHeaders } from '@angular/common/http';
import { retry, catchError } from 'rxjs/operators';
import * as i4 from '@angular/common';
import * as i10 from '@angular/material/core';
import MultiLineString from 'ol/geom/MultiLineString';
import MultiPolygon from 'ol/geom/MultiPolygon';
import MultiPoint from 'ol/geom/MultiPoint';
import Group from 'ol/layer/Group';
import TileGrid from 'ol/tilegrid/TileGrid';
import TileWMS from 'ol/source/TileWMS';
import VectorTileLayer from 'ol/layer/VectorTile';
import VectorTileSource from 'ol/source/VectorTile';
import MVT from 'ol/format/MVT';
import styleFunction from 'ol-mapbox-style/dist/stylefunction';
import Heatmap from 'ol/layer/Heatmap';
import { register } from 'ol/proj/proj4';
import * as condition from 'ol/events/condition';
import Control from 'ol/control/Control';
import GeoJSON from 'ol/format/GeoJSON';
import TileImage from 'ol/source/TileImage';
import Modify from 'ol/interaction/Modify';
import Select from 'ol/interaction/Select';
import FullScreen from 'ol/control/FullScreen';
import Draw, { createRegularPolygon, createBox } from 'ol/interaction/Draw';
import CircleShape from 'ol/geom/Circle';
import Snap from 'ol/interaction/Snap';
import Zoom from 'ol/control/Zoom';
import proj4 from 'proj4';
import Cluster from 'ol/source/Cluster';
import { setDefaultOptions, loadModules } from 'esri-loader';

class GoogleMapLoaderService {
    constructor() {
        this.URL = 'https://maps.googleapis.com/maps/api/js';
        this.KEY = null;
        this.CLIENT = null;
        this.SENSOR = false;
        this.VERSION = '3.14';
        this.LIBRARIES = null;
        this.WINDOW_CALLBACK_NAME = '__google_maps_api_provider_initializator__';
        this.script = null;
        this.google = null;
        this.loading = false;
        this.callbacks = [];
        this.onLoadEvents = [];
    }
    load() {
        let url = this.URL;
        if (this.SENSOR === true) {
            url += '?sensor=true';
        }
        else {
            url += '?sensor=false';
        }
        if (this.KEY != null) {
            url += '&key=' + this.KEY;
        }
        if (this.CLIENT != null) {
            url += '&client=' + this.CLIENT + '&v=' + this.VERSION;
        }
        if (this.LIBRARIES != null) {
            url += '&libraries=' + this.LIBRARIES;
        }
        url += '&callback=' + this.WINDOW_CALLBACK_NAME;
        // console.log('******** google-map-loader.ts, window.google = ' + window.google);
        this.google = window.google;
        const scriptLoadingPromise = new Promise((resolve, reject) => {
            if (this.google == null) {
                this.script = document.createElement('script');
                this.script.type = 'text/javascript';
                this.script.src = url;
                document.body.appendChild(this.script);
                (window)[this.WINDOW_CALLBACK_NAME] = () => {
                    this.google = window.google;
                    resolve(this.google);
                };
                this.script.onerror = (error) => { reject(error); };
            }
            else {
                resolve(this.google);
            }
        });
        return scriptLoadingPromise;
    }
    load_OLD() {
        return new Promise((resolve) => {
            if (this.google === null) {
                if (this.loading === true) {
                    resolve(this.google);
                }
                else {
                    this.loading = true;
                    window[this.WINDOW_CALLBACK_NAME] = (function (self) {
                        return function () {
                            self.google = null;
                            self.loading = false;
                            self.callbacks = [];
                            self.onLoadEvents = [];
                            if (typeof window.google !== 'undefined') {
                                delete window.google;
                            }
                            if (typeof window[self.WINDOW_CALLBACK_NAME] !== 'undefined') {
                                delete window[self.WINDOW_CALLBACK_NAME];
                            }
                            if (self.script !== null) {
                                self.script.parentElement.removeChild(self.script);
                                self.script = null;
                            }
                        };
                    })(this);
                    let url = this.URL;
                    if (this.SENSOR === true) {
                        url += '?sensor=true';
                    }
                    else {
                        url += '?sensor=false';
                    }
                    if (this.KEY != null) {
                        url += '&key=' + this.KEY;
                    }
                    if (this.CLIENT != null) {
                        url += '&client=' + this.CLIENT + '&v=' + this.VERSION;
                    }
                    if (this.LIBRARIES != null) {
                        url += '&libraries=' + this.LIBRARIES;
                    }
                    url += '&callback=' + this.WINDOW_CALLBACK_NAME;
                    this.script = document.createElement('script');
                    this.script.type = 'text/javascript';
                    this.script.src = url;
                    this.script.onload = () => {
                        resolve(window.google);
                    };
                    document.body.appendChild(this.script);
                }
            }
            else {
                resolve(this.google);
            }
        });
    }
}
/** @nocollapse */ /** @nocollapse */ GoogleMapLoaderService.ɵfac = function GoogleMapLoaderService_Factory(t) { return new (t || GoogleMapLoaderService)(); };
/** @nocollapse */ /** @nocollapse */ GoogleMapLoaderService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: GoogleMapLoaderService, factory: GoogleMapLoaderService.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(GoogleMapLoaderService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return []; }, null); })();

class SclMapConstantService {
}
SclMapConstantService.MAP_PRIMARY_ASSET = 'https://fileshare.formbird.com/fb/sc-component/map-icons/primary.png';
SclMapConstantService.MAP_SECONDARY_ASSET = 'https://fileshare.formbird.com/fb/sc-component/map-icons/secondary.png';
SclMapConstantService.MAP_MARKER = 'https://fileshare.formbird.com/fb/sc-component/map-icons/marker.png';
SclMapConstantService.ASSET_PRIMARY_TYPE = 'primaryAsset';
SclMapConstantService.ASSET_SECONDARY_TYPE = 'secondaryAsset';
SclMapConstantService.AVL_SPEED_BEGINNING = 'https://fileshare.formbird.com/fb/sc-component/map-icons/pin30';
SclMapConstantService.HEADING_THRESHOLD_H0 = 22.5;
SclMapConstantService.HEADING_THRESHOLD_H1 = 67.5;
SclMapConstantService.HEADING_THRESHOLD_H2 = 112.5;
SclMapConstantService.HEADING_THRESHOLD_H3 = 157.5;
SclMapConstantService.HEADING_THRESHOLD_H4 = 202.5;
SclMapConstantService.HEADING_THRESHOLD_H5 = 247.5;
SclMapConstantService.HEADING_THRESHOLD_H6 = 292.5;
SclMapConstantService.HEADING_THRESHOLD_H7 = 337.5;
SclMapConstantService.DEFAULT_SEARCH_DELAY = 500;
SclMapConstantService.DEFAULT_SEARCH_LENGTH = 3;
SclMapConstantService.AVL_SPEED_H0 = '_h0';
SclMapConstantService.AVL_SPEED_H1 = '_h1';
SclMapConstantService.AVL_SPEED_H2 = '_h2';
SclMapConstantService.AVL_SPEED_H3 = '_h3';
SclMapConstantService.AVL_SPEED_H4 = '_h4';
SclMapConstantService.AVL_SPEED_H5 = '_h5';
SclMapConstantService.AVL_SPEED_H6 = '_h6';
SclMapConstantService.AVL_SPEED_H7 = '_h7';
SclMapConstantService.EPSG_3857 = 'EPSG:3857';
SclMapConstantService.EPSG_4326 = 'EPSG:4326';
SclMapConstantService.MAP_MARKER_ARROW = 'https://fileshare.formbird.com/fb/sc-component/map-icons/arrow.png';
SclMapConstantService.MAP_MARKER_CROSS_GREEN = 'https://fileshare.formbird.com/fb/sc-component/map-icons/CrosshairGreen.gif';
SclMapConstantService.COMP_TYPE_BOUNDARY = 0; // SclMapConstantService.
SclMapConstantService.COMP_TYPE_ADDRESS_MAP = 1;
SclMapConstantService.COMP_TYPE_STREET_ADDRESS = 2;
SclMapConstantService.COMP_TYPE_SELECTED_ASSET = 3;
SclMapConstantService.DRAWING_MODE_ALL = 0;
SclMapConstantService.DRAWING_MODE_SINGLE = 1;
SclMapConstantService.DRAWING_MODE_MULTI = 2;
SclMapConstantService.STREET = {
    type: 'Feature',
    properties: {
        type: 'street',
        unitNo: '',
        streetNo: '',
        street: '',
        suburb: '',
        postcode: '',
        locationDescription: '',
        country: '',
        iconImage: '',
        iconSize: '',
        state: ''
    },
    geometry: {
        type: 'Point',
        coordinates: []
    }
}; // 15925
SclMapConstantService.DEFAULT_MAP_PARAMETERS = {
    mapViews: [
        {
            serverType: 'tile',
            url: 'https://tile.openstreetmap.org/{z}/{x}/{y}.png',
            crossOrigin: null
        }
    ]
}; // 15754

const compiledHandlebarsTemplates = {};
// this is clone from sclHandlebars.ts but using for mapping and has different parameter
const sclMapHandlebars = (() => {
    return {
        initHandlebars(helpers) {
            // Adding some standard helpers
            // Comparison
            Handlebars.registerHelper('ifEquals', function (arg1, arg2, options) {
                return (arg1 === arg2) ? options.fn(this) : options.inverse(this);
            });
            Handlebars.registerHelper('ifNotEquals', function (arg1, arg2, options) {
                return (arg1 !== arg2) ? options.fn(this) : options.inverse(this);
            });
            Handlebars.registerHelper('switch', function (value, options) {
                let that = {};
                that.switch_value = value;
                that.switch_break = false;
                return options.fn(that);
            });
            Handlebars.registerHelper('case', function (value, options) {
                if (value === this.switch_value) {
                    this.switch_break = true;
                    return options.fn(this);
                }
            });
            Handlebars.registerHelper('default', function (value, options) {
                if (this.switch_break === false) {
                    return value;
                }
            });
            // Date handling
            Handlebars.registerHelper('dateFormat', function (date, format, options) { return moment(date).format(format); });
            Handlebars.registerHelper('dateAdd', function (date, amount, what, options) { return moment(date).add(amount, what).format(); });
            Handlebars.registerHelper('dateFromNow', function (date, options) { return moment(date).fromNow(); });
            Handlebars.registerHelper('dateToNow', function (date, options) { return moment(date).toNow(); });
            Handlebars.registerHelper('dateCalendar', function (date, options) { return moment(date).calendar(); });
            // If component has helpers defined add them in too
            if (typeof helpers !== 'undefined' && helpers !== null) {
                for (const helper of helpers) {
                    if (typeof helper.name === 'string' && typeof helper.function === 'string') {
                        let helpFunc = helper.function;
                        if (typeof helpFunc === 'string') {
                            helpFunc = new Function('return ' + helpFunc)();
                        }
                        Handlebars.registerHelper(helper.name, helpFunc);
                    }
                }
            }
        },
        checkRegisteredHelpers(helpers) {
            if (!helpers) {
                return;
            }
            // console.log('%c ibefore checkRegisteredHelpers : ', 'color:blue');
            // console.log(Handlebars.helpers);
            let isRegistered = true;
            for (let i = 0; i < helpers.length; i++) {
                if (typeof helpers[i].name === 'string' && typeof helpers[i].function === 'string') {
                    if (!(helpers[i].name in Handlebars.helpers)) {
                        isRegistered = false;
                        break;
                    }
                }
            }
            if (!isRegistered) {
                sclMapHandlebars.initHandlebars(helpers);
            }
        },
        processHandlebars(handlebarsString, data, helpers, contextParams, options) {
            if (handlebarsString == null || typeof handlebarsString === 'undefined') {
                return '';
            }
            if ((typeof handlebarsString === 'string' || handlebarsString instanceof String)
                && (handlebarsString.indexOf('{{') < 0)) {
                return handlebarsString;
            }
            sclMapHandlebars.checkRegisteredHelpers(helpers);
            let hStr;
            if ((typeof handlebarsString === 'string' || handlebarsString instanceof String)) {
                hStr = handlebarsString;
            }
            else {
                hStr = JSON.stringify(handlebarsString);
            }
            // begin : 14274
            const handlebarsContext = {
                document: contextParams.doc,
                doc: contextParams.doc,
                account: contextParams.account,
                tpl: contextParams.tpl,
                tplItem: contextParams.tplItem // the current components configuration details
            };
            const invalidField = ['document', 'doc', 'account', 'tpl', 'componentDefinition',
                'results', 'resultsCount', 'resultsIndex', 'result', 'row'];
            if (data) {
                if (Object(data) === data) { // if the second parameter is object has property
                    for (const f in data) {
                        if (f === 'queryResultDocument') {
                            handlebarsContext.row = data[f];
                            handlebarsContext.result = data[f];
                            for (const j in data[f]) {
                                if (data[f].hasOwnProperty(j)) {
                                    if (invalidField.indexOf(j) > -1) {
                                        console.log('Handlebars Context Error: the field ' + j
                                            + ' is already present in document documentId so could not be set.'
                                            + ' It\'s values will NOT be available to handlebars expressions.'
                                            + ' Please advise your Application Developer to not use this field name if possible');
                                        continue;
                                    }
                                    handlebarsContext[j] = data[f][j];
                                }
                            }
                        }
                        else {
                            if (handlebarsContext.hasOwnProperty(f)) {
                                console.log('Handlebars Context Error: the field ' + f
                                    + ' is already present in document documentId so could not be set.'
                                    + ' It\'s values will NOT be available to handlebars expressions.'
                                    + ' Please advise your Application Developer to not use this field name if possible');
                                continue;
                            }
                            handlebarsContext[f] = data[f];
                        }
                    }
                }
                else {
                    console.log('Handlebars Context Error: object ' + data + ' wasn\'t passed in and the parameters is being ignored');
                }
            }
            // end : 14274
            // console.log('handlebarsContext = ' + JSON.stringify(handlebarsContext));
            let result = null;
            try {
                let template;
                if (options?.handlebarsTemplateName) {
                    // cache the template so it can be used in subsequent runs
                    const templateKey = `${contextParams.tpl.documentId}_${contextParams.tplItem.name}_${options.handlebarsTemplateName}`;
                    if (compiledHandlebarsTemplates[templateKey]) {
                        template = compiledHandlebarsTemplates[templateKey];
                    }
                    else {
                        template = Handlebars.compile(hStr);
                        compiledHandlebarsTemplates[templateKey] = template;
                    }
                }
                else {
                    template = Handlebars.compile(hStr);
                }
                result = template(handlebarsContext);
            }
            catch (err) {
                err.hStr = hStr;
                console.log(err);
            }
            return result;
        },
        processIntHandlebars(handlebarsString, data, helpers, contextParams, options) {
            const hStr = sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options);
            if (hStr) {
                return parseInt(hStr, 0);
            }
            else {
                return 0;
            }
        },
        processFloatHandlebars(handlebarsString, data, helpers, contextParams, options) {
            const hStr = sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options);
            if (hStr) {
                return parseFloat(hStr);
            }
            else {
                return 0;
            }
        },
        processBooleanHandlebars(handlebarsString, data, helpers, contextParams, options) {
            return sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options) === 'true';
        },
        processArrayHandlebars(handlebarsString, data, helpers, contextParams, options) {
            const hStr = sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options);
            if (hStr) {
                try {
                    const obj = JSON.parse(hStr);
                    const arr = [];
                    for (const i in obj) {
                        if (obj.hasOwnProperty(i)) {
                            arr.push(obj[i]);
                        }
                    }
                    return arr;
                }
                catch (err) {
                    return null;
                }
            }
            else {
                return null;
            }
        }
    };
})();

class SclUtilMapService {
    constructor() {
        this.sclUtilDate = new SclUtilDateService();
    }
    isContainAsset(asset, assets) {
        if (!assets) {
            return false;
        }
        for (let i = 0; i < assets.length; i++) {
            const ass = assets[i];
            if (ass.properties.linkAssets[0].documentId === asset.properties.linkAssets[0].documentId) {
                return true;
            }
        }
        return false;
    }
    isContainAssetWithType(asset, features) {
        if (!features) {
            return false;
        }
        for (let i = 0; i < features.length; i++) {
            const ass = features[i];
            if (ass.properties.linkAssets[0].documentId === asset.properties.linkAssets[0].documentId) {
                return true;
            }
        }
        return false;
    }
    containLayer(item, items) {
        if (!items) {
            return false;
        }
        for (let i = 0; i < items.length; i++) {
            const pos = items[i];
            if (pos === 'All' || pos === 'all') {
                return false;
            }
        }
        for (let i = 0; i < items.length; i++) {
            const pos = items[i];
            if (item === pos) {
                return true;
            }
        }
        return false;
    }
    removeItemFromMap(id, sourceVector) {
        const fea = sourceVector.getFeatureById(id);
        if (fea) {
            sourceVector.removeFeature(fea);
        }
    }
    getIdxAssetByType(features, type) {
        for (let i = 0; i < features.length; i++) {
            if (features[i].properties.type === type) {
                return i;
            }
        }
        return -1;
    }
    getQueryGeo(coor, coorNext, filter, geoJsonField) {
        // if (!filter) { return null; }
        let res;
        let filterObj;
        if (typeof filter === 'string') {
            res = filter.replace(/'/g, '"');
            filterObj = JSON.parse(res);
        }
        else {
            filterObj = filter;
        }
        let command = '';
        if (geoJsonField) {
            command = geoJsonField + '.features.geometry';
        }
        else {
            command = 'features.geometry';
        }
        const feature = {};
        feature[command] = {
            shape: {
                type: 'envelope',
                coordinates: [coor, coorNext]
            },
            relation: 'intersects'
        };
        const geoshape = {
            geo_shape: feature
        };
        if (filterObj?.query?.bool?.filter) {
            filterObj.query.bool.filter.push(geoshape);
        }
        else if (filterObj?.query?.bool?.must) {
            filterObj.query.bool.must.push(geoshape);
        }
        const query = JSON.stringify(filterObj);
        // logger.info("Query get avl event is " + query);
        return query;
    }
    getPointFeature(location, image, name, id, relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName) {
        const graphPoint = new Feature(new geom.Point(location));
        const properties = {
            icon: image,
            name,
            id
        };
        if (color) {
            properties.color = color;
        }
        if (tooltip) {
            properties.tooltip = tooltip;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (type) {
            properties.type = type;
        }
        if (anchor) {
            properties.anchor = anchor;
        }
        if (layerName) {
            properties.layerName = layerName;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset.hasOwnProperty(field)) {
                    const value = relatedAsset[field];
                    properties[field] = value;
                }
            }
        }
        const style = new Style({
            image: new Icon({
                anchor: [0.5, 0.5],
                anchorXUnits: 'fraction',
                anchorYUnits: 'fraction',
                opacity: 1.0,
                scale: 1,
                src: image
            })
        });
        graphPoint.setProperties(properties);
        graphPoint.setStyle(style);
        return graphPoint;
    }
    getLineFeature(coordinates, id, name, EPSG, layer, relatedAsset, color, popup, layerName, layerDisplayOnly, lineDash) {
        const feature = this.parseToLine(coordinates, id, EPSG);
        const typeFeature = 'line';
        const lineWidth = layer.lineWidth !== undefined ? layer.lineWidth : 4;
        const lineCap = layer.lineCap !== undefined ? layer.lineCap : 'round';
        const properties = {
            name: name,
            color: color,
            id: id,
            tooltip: popup,
            typeFeature: typeFeature,
            lineWidth: lineWidth,
            lineCap: lineCap
        };
        if (lineDash) {
            properties.lineDash = lineDash;
        }
        if (layerName) {
            properties.layerName = layerName;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset.hasOwnProperty(field)) {
                    properties[field] = relatedAsset[field];
                }
            }
        }
        feature.setProperties(properties);
        return feature;
    }
    parseRelatedField(source, relatedFields, primaryFields, secondaryFields) {
        const relatedAsset = {};
        if (primaryFields) {
            relatedAsset.primaryFields = {};
            for (const field in primaryFields) {
                if (primaryFields.hasOwnProperty(field)) {
                    const fieldAsset = primaryFields[field];
                    relatedAsset.primaryFields[field] = source[fieldAsset];
                }
            }
        }
        if (secondaryFields) {
            relatedAsset.secondaryFields = {};
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const fieldAsset = relatedFields[field];
                    relatedAsset.secondaryFields[field] = source[fieldAsset];
                }
            }
        }
        if (relatedFields) {
            relatedAsset.mainFields = {};
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const fieldAsset = relatedFields[field];
                    relatedAsset.mainFields[field] = source[fieldAsset];
                }
            }
        }
        return relatedAsset;
    }
    parseToLine(coor, id, toEPSG) {
        const array = [];
        for (let i = 0; i < coor.length; i++) {
            const coordinate = coor[i];
            const coordi = transform([parseFloat(coordinate[0]), parseFloat(coordinate[1])], 'EPSG:4326', toEPSG);
            array.push(coordi);
        }
        const lineFeature = new Feature(new LineString(array));
        lineFeature.setId(id);
        return lineFeature;
    }
    queryLastEvent(imei) {
        const filter = {
            query: {
                bool: {
                    filter: [
                        {
                            match: {
                                'features.properties.imei': {
                                    query: imei
                                }
                            }
                        }
                    ]
                }
            },
            /*"sort": [
                {
                    "features.properties.eventDate": "desc"
                }
            ],*/
            size: 1
        };
        console.log('Query get last event is ' + JSON.stringify(filter));
        return filter;
    }
    parseAVLData(data) {
        const feature = data.features[0];
        const lat = feature.geometry.coordinates[0];
        const lon = feature.geometry.coordinates[1];
        const properties = feature.properties;
        const object = {};
        object.latitude = lat;
        object.longitude = lon;
        const currentDate = new Date(properties.eventDate);
        object.eventDate = currentDate;
        object.speedKPH = parseInt(properties.speedKPH, 10);
        let streetNo;
        let street;
        let town;
        let postcode;
        let state;
        let country;
        if (properties && properties.address) {
            streetNo = properties.address.streetNo;
            street = properties.address.street;
            town = properties.address.town;
            postcode = properties.address.postcode;
            state = properties.address.state;
            country = properties.address.country;
        }
        let address = '';
        if (streetNo) {
            address = streetNo;
        }
        if (street) {
            address += ', ' + street;
        }
        if (state) {
            address += ', ' + state;
        }
        if (town) {
            address += ', ' + town;
        }
        if (postcode) {
            address += ', ' + postcode;
        }
        if (country) {
            address += ', ' + country;
        }
        if (address) {
            object.address = address;
        }
        return object;
    }
    parseAVLData_New(item) {
        const feature = item.locationGeo.features[0];
        const properties = feature.properties;
        const currentDate = new Date();
        const newEventDate = new Date(item.eventDate);
        const obj = {};
        obj.id = item._id;
        obj.imei = item.imeis[0];
        obj.longitude = item.locationGeo.features[0].geometry.coordinates[0];
        obj.latitude = item.locationGeo.features[0].geometry.coordinates[1];
        obj.speedKPH = item.speedKPH;
        obj.heading = item.heading;
        obj.eventDate = item.eventDate;
        obj.address = ''; // TO DO : s? parse khi có json
        return obj;
    }
    checkAVLSpeed(beginning, speedKPH, heading, speedA, speedB, speedC, speedD, speedE) {
        let result = beginning;
        let exist = false;
        if (speedKPH <= speedA) {
            result += '_red_dot';
            exist = true;
        }
        else if (speedA < speedKPH && speedKPH <= speedB) {
            result += '_orange';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        else if (speedB < speedKPH && speedKPH <= speedC) {
            result += '_green';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        else if (speedC < speedKPH && speedKPH <= speedD) {
            result += '_black';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        else if (speedD < speedKPH && speedKPH <= speedE) {
            result += '_yellow';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        result += '.png';
        if (exist === false) {
            result = 'styles/images/pp/pin30_black.png';
        }
        return result;
    }
    parseAVLTracePoint(point, timeFormat, imei) {
        // let coor = transform([parseFloat(point.latitude),
        // parseFloat(point.longitude)], 'EPSG:4326', 'EPSG:3857');
        const coor = transform([parseFloat(point.longitude), parseFloat(point.latitude)], 'EPSG:4326', 'EPSG:3857');
        const imeiContent = '<div><bold>IMEI : </bold> ' + imei + '</div>';
        let address = '';
        if (typeof point.address !== 'undefined') {
            address = '<div><bold>Address : </bold> ' + point.address + '</div>';
        }
        const gps = '<div><bold>GPS : </bold> ' + point.latitude.toFixed(4) + '/' +
            point.longitude.toFixed(4) + '</div>';
        const eventDate = new Date(point.eventDate);
        const dateFormat = this.sclUtilDate.parseDate(eventDate, timeFormat);
        const dateContent = '<div><bold>Time : </bold> ' + dateFormat + '</div>';
        const speedContent = '<div><bold>Speed : </bold> ' + point.speedKPH + '</div>';
        const tooltip = imeiContent + address + gps + dateContent + speedContent;
        const propertiesData = {
            'address': tooltip,
            'icon': point.icon
        };
        const pointFeature = new Feature(new geom.Point(coor));
        pointFeature.setProperties(propertiesData);
        return pointFeature;
    }
    constructQueryVehicleData(imeis, doc) {
        const feature = {};
        feature.imei = imeis;
        const terms = {
            terms: feature
        };
        const match = {
            match: {
                appTags: {
                    query: 'avlVehicle'
                }
            }
        };
        const filter = {
            query: {
                bool: {
                    filter: [terms, match]
                }
            }
        };
        const query = JSON.stringify(filter);
        // logger.info("Query imeis from list : " + query);
        const options = {};
        // there is no need to set the pageSize to the default. It only needs to be set if
        // it is different to the default
        // options.pageSize = SharedConstants.DEFAULT_PAGE_SIZE;
        options.filter = query;
        options.document = doc;
        return options;
    }
    constructQueryGeoZones(filter, doc) {
        const res = filter.replace(/'/g, '"');
        const filterObj = JSON.parse(res);
        const query = JSON.stringify(filterObj);
        // logger.info("Query geozone from  : " + query);
        const options = {};
        // there is no need to set the pageSize to the default. It only needs to be set if
        // it is different to the default
        // options.pageSize = SharedConstants.DEFAULT_PAGE_SIZE;
        options.filter = query;
        options.document = doc;
        return options;
    }
    constructQueryDocument(docIds, doc) {
        const documentId = {};
        documentId.documentId = docIds;
        const terms = {
            terms: documentId
        };
        const filter = {
            query: {
                bool: {
                    filter: [terms]
                }
            }
        };
        const query = JSON.stringify(filter);
        // logger.info("Query documentId from list : " + query);
        const options = {};
        // there is no need to set the pageSize to the default. It only needs to be set if
        // it is different to the default
        // options.pageSize = SharedConstants.DEFAULT_PAGE_SIZE;
        options.filter = query;
        options.document = doc;
        return options;
    }
    queryVehicleInfo(imei) {
        const filter = {
            query: {
                bool: {
                    filter: [
                        {
                            match: {
                                imei: {
                                    query: imei
                                }
                            }
                        }
                    ]
                }
            }
        };
        const query = JSON.stringify(filter);
        // logger.info("The Query vehicle info is " + query);
        return query;
    }
    parseAVLQuery(date, imei, numOffSet) {
        const startDate = new Date(date);
        startDate.setHours(0);
        startDate.setMinutes(0);
        startDate.setSeconds(0);
        startDate.setHours(startDate.getHours() + numOffSet);
        // logger.info("Start Date is " + startDate);
        const endDate = new Date(date);
        endDate.setHours(23);
        endDate.setMinutes(59);
        endDate.setSeconds(59);
        endDate.setHours(endDate.getHours() + numOffSet);
        // logger.info("end Date is " + endDate);
        const format = 'YYYY-MM-DD HH:mm:ss';
        const startDateFormat = this.sclUtilDate.parseDate(startDate, format);
        const endDateFormat = this.sclUtilDate.parseDate(endDate, format);
        const filter = {
            query: {
                bool: {
                    filter: [
                        {
                            match: {
                                'features.properties.imei': {
                                    query: imei
                                }
                            }
                        },
                        {
                            range: {
                                'features.properties.eventDate': {
                                    gte: startDateFormat,
                                    lte: endDateFormat,
                                    format: 'yyyy-MM-dd HH:mm:ss'
                                }
                            }
                        }
                    ]
                }
            },
            sort: [
                {
                    'features.properties.eventDate': 'asc'
                }
            ]
        };
        const query = JSON.stringify(filter);
        // logger.info("Query get list trace event is " + query);
        return query;
    }
    positionView(view, lng, lat, zoom, EPSG) {
        lat = typeof lat !== 'undefined' ? lat : 0;
        lng = typeof lng !== 'undefined' ? lng : 0;
        zoom = typeof zoom !== 'undefined' ? zoom : 2;
        EPSG = typeof EPSG !== 'undefined' ? EPSG : 'EPSG:3857';
        view.setCenter(transform([lng, lat], 'EPSG:4326', EPSG));
        view.setZoom(zoom);
        return view;
    }
    setView(lng, lat, zoom, EPSG, minResolution, maxResolution) {
        lat = typeof lat !== 'undefined' ? lat : 0;
        lng = typeof lng !== 'undefined' ? lng : 0;
        zoom = typeof zoom !== 'undefined' ? zoom : 2;
        EPSG = typeof EPSG !== 'undefined' ? EPSG : 'EPSG:3857';
        let view;
        if (minResolution && maxResolution) {
            view = new View({
                projection: EPSG,
                center: transform([lng, lat], 'EPSG:4326', EPSG),
                zoom,
                minResolution,
                maxResolution
            });
        }
        else {
            view = new View({
                projection: EPSG,
                center: transform([lng, lat], 'EPSG:4326', EPSG),
                zoom,
                minZoom: 2
            });
        }
        return view;
    }
    createAddressQuery(geoJsonField) {
        const filter = {
            query: {
                bool: {
                    filter: [
                        { exists: { field: geoJsonField } },
                        { term: { appTags: 'property' } }
                    ]
                }
            }
        };
        console.log('The Query Address is ' + JSON.stringify(filter));
        return filter;
    }
    getDocument(result) {
        const prefix = '_source';
        let hold = result;
        if (result && prefix) {
            const split = prefix.split('.');
            for (let i = 0; i < split.length; i++) {
                if (split[i]) {
                    if (hold[split[i]]) {
                        hold = hold[split[i]];
                    }
                    else {
                        hold = null;
                        break;
                    }
                }
                else {
                    break;
                }
            }
        }
        return hold;
    }
    fit(ConfigService, sourceVector, view, map, maxZoomComponent) {
        let maxZoom = 15;
        if (maxZoomComponent) {
            maxZoom = maxZoomComponent;
        }
        else {
            if (ConfigService.clientConfig().maxZoomLevel) {
                maxZoom = ConfigService.clientConfig().maxZoomLevel;
            }
        }
        const featuresExtent = olExtent.createEmpty();
        sourceVector.getFeatures().forEach(function (feature) {
            olExtent.extend(featuresExtent, feature.getGeometry().getExtent());
        });
        view.fit(featuresExtent, map.getSize(), { maxZoom });
    }
    initializeMap(ConfigService, controls, target, view, interactions, disableMouseWheel, mapLayers, multiLayers) {
        let sourceXYZ = [];
        if (multiLayers && multiLayers.length > 0) {
            sourceXYZ = multiLayers;
        }
        else {
            if (mapLayers) {
                sourceXYZ.push(mapLayers);
            }
            else {
                const tile = new TileLayer({
                    source: new OSM({
                        url: ConfigService.clientConfig().openLayers.tileServer.url,
                        crossOrigin: ConfigService.clientConfig().openLayers.tileServer.crossOrigin,
                        wrapDateLine: false,
                        wrapX: false,
                        noWrap: true
                    })
                });
                sourceXYZ.push(tile);
            }
        }
        let mouseWheel = true;
        if (disableMouseWheel) {
            mouseWheel = false;
        }
        const map = new Map({
            controls: olControl.defaults().extend([
                new olControl.FullScreen()
            ]),
            interactions: olInteraction.defaults({ mouseWheelZoom: mouseWheel }),
            layers: sourceXYZ,
            target,
            view
        });
        if (controls.length) {
            for (let i = 0; i < controls.length; i++) {
                map.addControl(controls[i]);
            }
        }
        if (interactions.length) {
            for (let i = 0; i < interactions.length; i++) {
                map.addInteraction(interactions[i]);
            }
        }
        return map;
    }
    initializeMapDefault(controls, target, view, interactions, disableMouseWheel, mapLayers, multiLayers) {
        let sourceXYZ = [];
        if (multiLayers && multiLayers.length > 0) {
            sourceXYZ = multiLayers;
        }
        else {
            if (mapLayers) {
                sourceXYZ.push(mapLayers);
            }
            else {
                const tile = new TileLayer({
                    source: new OSM({
                        wrapDateLine: false,
                        wrapX: false,
                        noWrap: true
                    })
                });
                sourceXYZ.push(tile);
            }
        }
        let mouseWheel = true;
        if (disableMouseWheel) {
            mouseWheel = false;
        }
        const map = new Map({
            controls: olControl.defaults().extend([
                new olControl.FullScreen()
            ]),
            interactions: olInteraction.defaults({ mouseWheelZoom: mouseWheel }),
            layers: sourceXYZ,
            target,
            view
        });
        if (controls.length) {
            for (let i = 0; i < controls.length; i++) {
                map.addControl(controls[i]);
            }
        }
        if (interactions.length) {
            for (let i = 0; i < interactions.length; i++) {
                map.addInteraction(interactions[i]);
            }
        }
        return map;
    }
    getPointStyle(color, icon, imageAnchor, zIndex) {
        let zIn = 0;
        if (zIndex) {
            zIn = zIndex;
        }
        let pointColor = 'green';
        if (color) {
            pointColor = color;
        }
        let image = new Circle({
            radius: 7,
            fill: new Fill({
                color: '#ffcc33'
            })
        });
        if (icon) {
            let anchor = [0.5, 0.5];
            if (imageAnchor) {
                anchor = imageAnchor;
            }
            image = new Icon(({
                src: icon,
                anchor
            }));
        }
        const style = new Style({
            fill: new Fill({
                color: 'rgba(255, 255, 255, 0.2)'
            }),
            stroke: new Stroke({
                color: pointColor,
                width: 2
            }),
            zIndex: zIn,
            image
        });
        return style;
    }
    getLineStyle(color, properties) {
        let lineColor = 'blue';
        if (color) {
            lineColor = color;
        }
        const style = new Style({
            image: new Circle({
                radius: 7,
                fill: new Fill({
                    color: '#ffcc33'
                })
            })
        });
        const stroke = new Stroke({
            color: lineColor,
            width: 2
        });
        if (properties) {
            if (properties.lineWidth) {
                stroke.setWidth(properties.lineWidth);
            }
            if (properties.lineDash) {
                stroke.setLineDash(properties.lineDash);
            }
            if (properties.lineCap) {
                stroke.setLineCap(properties.lineCap);
            }
        }
        style.setStroke(stroke);
        let fillColor = 'rgba(255, 255, 255, 0.2)';
        if (properties && properties.fillColor) {
            // fillColor = properties.fillColor;
            color = asArray(properties.fillColor);
            color = color.slice();
            if (properties.fillOpacity) {
                color[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = color;
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        return style;
    }
    getWrapLon(value) {
        const worlds = Math.floor((value + 180) / 360);
        return value - (worlds * 360);
    }
    getGeocodeAddress(url, key, text, field) {
        // let link = "https://www.geocode.farm/v3/json/forward/?addr=" + text + "&key=a2338e05-e3cb425e93ad-109049bfb516";
        let link = url + text;
        if (key) {
            link = link + '&key=' + key;
        }
        if (field) {
            if (field.country) {
                link = link + '&country=' + field.country;
            }
            if (field.language) {
                link = link + '&lang=' + field.language;
            }
        }
        return link;
    }
    getGoogleAddress(text, key) {
        // https://maps.googleapis.com/maps/api/place/textsearch/json?query=123+main+street&key=YOUR_API_KEY
        // let link = "https://maps.googleapis.com/maps/api/place/textsearch/json?query=" + text + "&key=" + key;
        const link = 'https://maps.googleapis.com/maps/api/place/autocomplete/json?query=' + text + '&key=' + key;
        return link;
    }
    getGeocodeCoordinate(url, lat, lon, field, key) {
        let link = url + '?lat=' + lat + '&lon=' + lon + '&key=' + key + '&count=1';
        if (field) {
            if (field.country) {
                link = link + '&country=' + field.country;
            }
            if (field.language) {
                link = link + '&lang=' + field.language;
            }
        }
        return link;
    }
    getAllCoordinates(feature) {
        const coords = [];
        if (feature.geometry.type === 'Polygon') {
            let k;
            for (k = 0; k < feature.geometry.coordinates[0].length; ++k) {
                coords.push(feature.geometry.coordinates[0][k]);
            }
        }
        else if (feature.geometry.type === 'LineString') {
            let j;
            for (j = 0; j < feature.geometry.coordinates.length; ++j) {
                coords.push(feature.geometry.coordinates[j]);
            }
        }
        else if (feature.geometry.type === 'Point') {
            if (feature.geometry.coordinates.length > 0) {
                coords.push(feature.geometry.coordinates);
            }
        }
        else if (feature.geometry.type === 'MultiPolygon') {
            let k;
            for (k = 0; k < feature.geometry.coordinates.length; ++k) { // loop through each multipolygon
                const pol = feature.geometry.coordinates[k];
                let k1;
                for (k1 = 0; k1 < pol.length; ++k1) { // loop throuch each polygon in this multipolygon
                    const pol1 = pol[k1];
                    if (pol1.length >= 3) { // a valid polygon should have >= 3 coordinates
                        let k2;
                        for (k2 = 0; k2 < pol1.length; ++k2) { // loop throuch each coordinates in this polygon
                            coords.push(pol1[k2]);
                        }
                    }
                }
            }
        }
        else if (feature.geometry.type === 'MultiLineString') {
            let k;
            for (k = 0; k < feature.geometry.coordinates.length; ++k) { // loop through each LineString
                const pol = feature.geometry.coordinates[k];
                if (pol.length >= 2) {
                    let k1;
                    for (k1 = 0; k1 < pol.length; ++k1) { // loop throuch each coordinates in this LineString
                        coords.push(pol[k1]);
                    }
                }
            }
        }
        else if (feature.geometry.type === 'MultiPoint') {
            let k;
            for (k = 0; k < feature.geometry.coordinates.length; ++k) { // loop through each LineString
                coords.push(feature.geometry.coordinates[k]);
            }
        }
        return coords;
    }
    isValidFeature(f) {
        if (f.geometry.type === 'LineString') {
            if (f.geometry.coordinates.length >= 2) {
                return true;
            }
        }
        else if (f.geometry.type === 'Polygon') {
            if (f.geometry.coordinates.length >= 1 && f.geometry.coordinates[0].length >= 3) {
                return true;
            }
        }
        else if (f.geometry.type === 'Point' && f.geometry.coordinates.length > 1) {
            return true;
        }
        else if (f.geometry.type === 'MultiPoint' && f.geometry.coordinates.length > 1) {
            return true;
        }
        else if (f.geometry.type === 'MultiLineString') {
            let k;
            for (k = 0; k < f.geometry.coordinates.length; ++k) { // loop through each LineString
                const pol = f.geometry.coordinates[k];
                if (pol.length < 2) {
                    return false;
                }
            }
            return true;
        }
        else if (f.geometry.type === 'MultiPolygon') {
            let k;
            for (k = 0; k < f.geometry.coordinates.length; ++k) { // loop through each multipolygon
                const pol = f.geometry.coordinates[k];
                let k1;
                for (k1 = 0; k1 < pol.length; ++k1) { // loop throuch each polygon in this multipolygon
                    const pol1 = pol[k1];
                    if (pol1.length < 3) { // a valid polygon should have >= 3 coordinates
                        return false;
                    }
                }
            }
            return true;
        }
        return false;
    }
    transformEPSG(long, lat, from, to) {
        const location = transform([parseFloat(long), parseFloat(lat)], from, to);
        return location;
    }
    transformCoordinate(coordinate, from, to) {
        const location = transform(coordinate, from, to);
        return location;
    }
    parseCellTemplate(tmpl) {
        let str = '';
        let errStr = '';
        try {
            let hasUndefined = false;
            const tmplVars = tmpl.match(/{{.+?}}/g || {}).map(function (data) { return data.slice(2, -2); });
            if (!tmplVars) {
                return tmpl;
            }
            for (let i = 0; i < tmplVars.length; i++) {
                // Removing the regex as it just causes problems with special chars
                /*let reg = new RegExp("{{"+tmplVars[i].replace(/\[/g,"\\\[").replace(/\]/g,"\\\]").
                 replace(/\(/g,"\\\(").replace(/\)/g,"\\\)").
                 replace(/\|/g,"\\\|")+"}}");
                 */
                // Just use a substring replace instead of the regex
                const reg = '{{' + tmplVars[i] + '}}';
                if (eval(tmplVars[i])) {
                    tmpl = tmpl.replace(reg, '"' + eval(tmplVars[i]) + '"');
                }
                else {
                    hasUndefined = true;
                    errStr = tmplVars[i] + ' ; ' + errStr;
                    tmpl = tmpl.replace(reg, '');
                }
            }
            if (hasUndefined) {
                // logger.info("sc-datatables cellTemplate Error : variable is Undefined in template " + errStr);
            }
            str = tmpl;
        }
        catch (e) {
            console.error('sc-datatables cellTemplate Error : variable in ' + tmpl +
                ' is Undefined in Document: ' + ' Error : ' + e.message);
            str = '';
        }
        return str;
    }
    // Deprecated - use sclHandlebars.processHandlebars()
    parseHandlerBar(stringHandlerbars, data) {
        if (stringHandlerbars == null) {
            return '';
        }
        const template = Handlebars.compile(stringHandlerbars);
        const result = template(data);
        return result;
    }
    preSuffixNumbers(pre, suff, num) {
        let fixedNum;
        fixedNum = (pre != null ? pre : '') + (num != null ? num : '') + (suff != null ? suff : '');
        if (fixedNum != null && fixedNum.length > 0) {
            return fixedNum;
        }
        else {
            return null;
        }
    }
    parseAddress(address) {
        const sugg = {};
        sugg.street = address.addressLine;
        const res = address.pos[0].split(',');
        sugg.coordinates = {},
            sugg.coordinates.latitude = res[0];
        sugg.coordinates.longitude = res[1];
        sugg.address = {},
            sugg.address.unitNo = this.preSuffixNumbers(address.unitNumberPrefix, address.unitNumberSuffix, address.unitNumber);
        sugg.address.street_number = this.preSuffixNumbers(address.thoroughfareNumberFromPrefix, address.thoroughfareNumberFromSuffix, address.thoroughfareNumberFrom);
        sugg.address.street_name = '';
        if (address.thoroughfareName) {
            sugg.address.street_name = address.thoroughfareName;
        }
        if (address.thoroughfareTrailingType) {
            sugg.address.street_name += ' ' + address.thoroughfareTrailingType;
        }
        sugg.address.locality = address.locality;
        sugg.address.postal_code = address.postcode;
        if (!address.country) {
            sugg.address.country = 'Australia';
        }
        sugg.address.admin_1 = address.state;
        return sugg;
    }
    createBorderMandatory(doc) {
        // let mandatoryF;
        // if( typeof scope.componentDefinition.mandatoryFields === 'undefined' || scope.componentDefinition.mandatoryFields === null ){
        //     mandatoryF = [ "primaryAsset" ];
        // }
        // else {
        //     mandatoryF = scope.componentDefinition.mandatoryFields;
        // }
        // angular.forEach(mandatoryF, function(value, key) {
        //     //include mandatory=true|false in condition of function fnAddMandatoryBorder
        //     if( typeof scope.componentDefinition.mandatory === 'undefined' || scope.componentDefinition.mandatory === null ){
        //         scope.componentDefinition.mandatory=false;
        //     }
        //     if(scope.componentDefinition.mandatory){
        //         let target = "";
        //         if(angular.equals(value,"unitNo")){
        //             target =  angular.element(element).find("#"+'unitNumD')[0];
        //         } else if(angular.equals(value,"streetNo")){
        //             target =  angular.element(element).find("#"+'streetD')[0];
        //         } else if(angular.equals(value,"street")){
        //             target =  angular.element(element).find("#"+'streetNameD')[0];
        //         } else if(angular.equals(value,"suburb")){
        //             target =  angular.element(element).find("#"+'subUrbTownD')[0];
        //         } else if(angular.equals(value,"postcode")){
        //             target =  angular.element(element).find("#"+'postcodeD')[0];
        //         } else if(angular.equals(value,"country")){
        //             target =  angular.element(element).find("#"+'countryD')[0];
        //         } else if(angular.equals(value,"state")){
        //             target =  angular.element(element).find("#"+'stateD')[0];
        //         } else if(angular.equals(value,"locationDescription")){
        //             target =  angular.element(element).find("#"+'descriptionAddressD')[0];
        //         } else if(angular.equals(value,"coordinates")){
        //             target =  angular.element(element).find("#"+'latitudeD')[0];
        //             $(target).css('border','solid red 1px');
        //             target =  angular.element(element).find("#"+'longitudeD')[0];
        //         } else if(angular.equals(value,"primaryAsset")){
        //             target =  angular.element(element).find("#"+'primaryAsset')[0];
        //         } else if(angular.equals(value,"secondaryAsset")){
        //             target =  angular.element(element).find("#"+'secondaryAsset')[0];
        //         }
        //         $(target).css('border','solid red 1px');
        //     }
        // });
        // scope.change();
    }
    parseQuery(filter, geojsonField) {
        let filterObj;
        if (typeof filter === 'string') {
            const res = filter.replace(/'/g, '"');
            //// logger.info("Handlebars parsing before "+res);
            // res = scope.sclUtilMap.parseCellTemplate(res);
            //// logger.info("Handlebars parsing after"+res);
            filterObj = JSON.parse(res);
        }
        else {
            filterObj = filter;
        }
        if (geojsonField) {
            if (filterObj.query.bool.filter) {
                const term = {
                    term: {}
                };
                const value = geojsonField + '.type';
                term.term[value] = 'FeatureCollection';
                filterObj.query.bool.filter.push(term);
            }
            else if (filterObj.query.bool.must) {
                const exist = {
                    match: {}
                };
                const value = geojsonField + '.type';
                exist.match[value] = {
                    query: 'FeatureCollection'
                },
                    filterObj.query.bool.must.push(exist);
            }
        }
        const query = JSON.stringify(filterObj);
        // logger.info("The query is " + query);
        return filterObj;
    }
    processVicmapSearch(url, scope) {
        // jQuery.getJSON(url, null, function(addressResponse) {
        //     let result = (addressResponse.requestResult.result);
        //     if(result){
        //         let results = [];
        //         for (let k = 0; k < result.length; k++) {
        //             let r = result[k];
        //             let p = r.address;
        //             for (let f = 0; f < p.length; f++) {
        //                 let predict = p[f];
        //                 results.push(parseAddress(predict));
        //             }
        //         }
        //         $timeout(function () {
        //             scope.results.data = results;
        //         });
        //     }
        // });
        // return scope;
    }
    search(scope, text, mapField, psmaAutoCompleteURL, psmaKey) {
        // let newText = text.trim();
        // if(newText === scope.preText) return;
        // if(text !== undefined) {
        //     scope.results.data = [];
        //     scope.preText = text;
        //     scope.inputText = text;
        //     if(scope.geocoderDefaultState) text = text + ", " + scope.geocoderDefaultState;
        //     if(scope.geocoderDefaultCountry) text = text + ", " + scope.geocoderDefaultCountry;
        //     //logger.info("Checking for Address : " + text);
        //     let link = this.getGeocodeAddress(scope.autocompleteURL, scope.apiKey, text, mapField);
        //     if(scope.geocodeName === "vicmap"){
        //         link = this.getGeocodeAddress(scope.autocompleteURL, "", text);
        //         this.processVicmapSearch(link, scope);
        //     }
        //     else if(scope.geocodeName === "psma"){
        //         link = scope.psmaAutoCompleteURL + text;
        //         let apiKey = scope.psmaKey;
        //         //link = autocompleteURL + text;
        //         $http.get(link, { headers: {'API-Key': apiKey} }).then(function(data_result){
        //             if(data_result.statusText == "OK"){
        //                 let suggestions = data_result.data.suggest;
        //                 let results = [];
        //                 for(let i = 0; i < suggestions.length; ++i){
        //                     let sugg = {},
        //                     sugg.street = suggestions[i].address;//show in UI
        //                     sugg.id = suggestions[i].id;
        //                     results.push(sugg);
        //                 }
        //             }
        //             scope.results.data = results;
        //         });
        //     }else if(scope.geocodeName === "psmafarm"){
        //         link = scope.psmafarmAutoCompleteURL + text;
        //         $http.get(link, { headers: {'API-Key': scope.psmafarmKey} }).then(function(data_result){
        //             if(data_result.statusText == "OK"){
        //                 let suggestions = data_result.data.suggest;
        //                 let results = [];
        //                 for(let i = 0; i < suggestions.length; ++i){
        //                     let sugg = {},
        //                     sugg.street = suggestions[i].address;//show in UI
        //                     sugg.id = suggestions[i].id;
        //                     results.push(sugg);
        //                 }
        //             }
        //             scope.results.data = results;
        //         });
        //     }
        //     else {
        //         scope.lastLink = link;
        //         $http.get(link).then(function (data_result) {
        //             let data = data_result.data;
        //             if (data && data.geocoding_results && data.geocoding_results.STATUS.status === "SUCCESS") {
        //                 let suggestions = data.geocoding_results.RESULTS;
        //                 let results = [];
        //                 // check if the results are from the latest query not an earlier one that is out of sync
        //                 if ( data_result.config.url !== scope.lastLink ) {
        //                     //logger.info("Search results are from earlier query, "+data_result.config.url+" ignore this set");
        //                     return;
        //                 }
        //                 for (let i = 0; i < suggestions.length; i++) {
        //                     let predict = suggestions[i];
        //                     let sugg = {},
        //                     sugg.street = predict.formatted_address;
        //                     sugg.address = predict.ADDRESS;
        //                     sugg.coordinates = predict.COORDINATES;
        //                     results.push(sugg);
        //                 }
        //                 scope.results.data = results;
        //             }
        //         }).catch(function(error) {
        //             logger.error("Error : " + error);
        //         });
        //     }
        // }
        // return scope;
    }
    fillGoogleAddress(data, streetData) {
        for (let i = 0; i < data.address_components.length; i++) {
            const addressType = data.address_components[i].types[0];
            const val = data.address_components[i].long_name;
            if (addressType === 'subpremise') {
                streetData.properties.unitNo = val;
            }
            else if (addressType === 'street_number') {
                streetData.properties.streetNo = val;
            }
            else if (addressType === 'route') {
                streetData.properties.street = val;
            }
            else if (addressType === 'administrative_area_level_1') {
                streetData.properties.state = val;
            }
            else if (addressType === 'locality') {
                streetData.properties.suburb = val;
            }
            else if (addressType === 'postal_code') {
                streetData.properties.postcode = val;
            }
            else if (addressType === 'country') {
                streetData.properties.country = val;
            }
        }
        if (data.geometry && data.geometry.location) {
            streetData = this.checkStreetGeometry(streetData);
            if (!isNaN(data.geometry.location.lng)) {
                streetData.geometry.coordinates[0] = data.geometry.location.lng;
            }
            else {
                streetData.geometry.coordinates[0] = data.geometry.location.lng();
            }
            if (!isNaN(data.geometry.location.lat)) {
                streetData.geometry.coordinates[1] = data.geometry.location.lat;
            }
            else {
                streetData.geometry.coordinates[1] = data.geometry.location.lat();
            }
        }
        return streetData;
    }
    checkStreetGeometry(streetData) {
        if (!streetData.geometry) {
            const geometry = {
                type: 'Point',
                coordinates: []
            };
            streetData.geometry = geometry;
        }
        return streetData;
    }
    setTooltipPosition(scope, pixel) {
        // let result = {},
        // let featureLeftPos = pixel[0];
        // let featureTopPos = pixel[1];
        // result.left = featureLeftPos + 'px';
        // result.top = featureTopPos + 'px';
        // // set the tooltip position
        // let tooltipHorizontalPosition;
        // let tooltipVerticalPosition;
        // if (featureLeftPos < scope.mapCenter.x) {
        //     tooltipHorizontalPosition = "left";
        //     //featureLeftPos -= 10;
        // } else {
        //     tooltipHorizontalPosition = "right";
        //     //featureLeftPos += 25;
        // }
        // if (featureTopPos < scope.mapCenter.y) {
        //     tooltipVerticalPosition = "bottom";
        //     //featureTopPos += 10;
        // } else {
        //     tooltipVerticalPosition = "top";
        //     //featureTopPos -= 10;
        // }
        // result.tooltipPosition = tooltipVerticalPosition + "-" + tooltipHorizontalPosition;
        // //scope.infoPosition.left = featureLeftPos + 'px';
        // //scope.infoPosition.top = featureTopPos + 'px';
        // return result;
    }
    streetDataRemoveEmpty(street) {
        if (street.properties.hasOwnProperty('unitNo') && (street.properties.unitNo === null
            || street.properties.unitNo.trim().length === 0)) {
            delete street.properties.unitNo;
        }
        if (street.properties.hasOwnProperty('streetNo') && (street.properties.streetNo === null
            || street.properties.streetNo.trim().length === 0)) {
            delete street.properties.streetNo;
        }
        if (street.properties.hasOwnProperty('street') && (street.properties.street === null
            || street.properties.street.trim().length === 0)) {
            delete street.properties.street;
        }
        if (street.properties.hasOwnProperty('suburb') && (street.properties.suburb === null
            || street.properties.suburb.trim().length === 0)) {
            delete street.properties.suburb;
        }
        if (street.properties.hasOwnProperty('postcode') && (street.properties.postcode === null
            || street.properties.postcode.trim().length === 0)) {
            delete street.properties.postcode;
        }
        if (street.properties.hasOwnProperty('locationDescription') && (street.properties.locationDescription === null
            || street.properties.locationDescription.trim().length === 0)) {
            delete street.properties.locationDescription;
        }
        if (street.properties.hasOwnProperty('country') && (street.properties.country === null
            || street.properties.country.trim().length === 0)) {
            delete street.properties.country;
        }
        if (street.properties.hasOwnProperty('iconImage') && (street.properties.iconImage === null
            || street.properties.iconImage.trim().length === 0)) {
            delete street.properties.iconImage;
        }
        if (street.properties.hasOwnProperty('iconSize') && (street.properties.iconSize === null
            || street.properties.iconSize.trim().length === 0)) {
            delete street.properties.iconSize;
        }
        if (street.properties.hasOwnProperty('state') && (street.properties.state === null
            || street.properties.state.trim().length === 0)) {
            delete street.properties.state;
        }
    }
    createOverlay(container) {
        return new Overlay(({
            element: container,
            autoPan: true,
            positioning: 'center-center',
            autoPanAnimation: {
                duration: 250
            }
        }));
    }
    styleFunction(feature, resolution) {
        const p = feature.getProperties();
        const geometry = feature.getGeometry();
        if (geometry && geometry.getType() === 'Point') {
            let icon = '';
            if (p && p.icon) {
                icon = p.icon;
            }
            const stylePoint = [new Style({
                    image: new Icon(({
                        src: icon,
                        anchor: [0.5, 1]
                    }))
                })];
            return stylePoint;
        }
        const styles = [new Style({
                fill: new Fill({
                    color: 'rgba(255, 255, 255, 0.2)'
                }),
                stroke: new Stroke({
                    color: 'red',
                    width: 2
                }),
                image: new Circle({
                    radius: 7,
                    fill: new Fill({
                        color: '#ffcc33'
                    })
                })
            })];
        if (p && p.displayArrorHeads) {
            geometry.forEachSegment((start, end) => {
                const dx = end[0] - start[0];
                const dy = end[1] - start[1];
                const rotation = Math.atan2(dy, dx);
                // arrows
                styles.push(new Style({
                    geometry: new geom.Point(end),
                    image: new Icon({
                        src: SclMapConstantService.MAP_MARKER_ARROW,
                        anchor: [0.75, 0.5],
                        rotateWithView: false,
                        rotation: -rotation
                    })
                }));
            });
        }
        return styles;
    }
    parseLineString(coor, coor1, nextCoor, nextCoor1) {
        return new Feature(new geom.LineString([[coor, coor1], [nextCoor, nextCoor1]]));
    }
    dexieSearchFunction(filterFunc, pageNumber, numberPerPage) {
        return {
            dexieSearchFunction: function (db, callbackFunc) {
                try {
                    const fun = eval('(' + filterFunc + ')');
                    if (fun) {
                        fun(db, function (err, filterDocs) {
                            if (err) {
                                callbackFunc(err);
                            }
                            else {
                                let docs = [];
                                if (filterDocs && filterDocs.length > 0) {
                                    const size = numberPerPage || SharedConstants.DEFAULT_PAGE_SIZE;
                                    const page = pageNumber || SharedConstants.DEFAULT_PAGE;
                                    const docsArray = chunk(filterDocs, size);
                                    docs = nth(docsArray, page);
                                }
                                let results;
                                results = {};
                                results.total = filterDocs.length;
                                results.statusCode = UtilHttpStatus.OK;
                                results.data = docs;
                                results.searchProvier = 'dexie';
                                callbackFunc(null, results);
                            }
                        });
                    }
                }
                catch (err) {
                    console.log(err);
                    callbackFunc(err);
                }
            }
        };
    }
    calculateRotate(bearing, initialImageDirection, initialImageWheelDirection) {
        let calculateRotation = false;
        let calculateFlip = false;
        let rotation = 0;
        let isFlip = false;
        if (typeof (initialImageWheelDirection) == 'number' && (initialImageWheelDirection > 0 && initialImageWheelDirection <= 360)) {
            // we have wheels so may need to flip
            calculateFlip = true;
        }
        if (typeof (initialImageDirection) == 'number' && (initialImageDirection > 0 && initialImageDirection <= 360)) {
            // need to calculate rotation
            calculateRotation = true;
        }
        if (typeof (bearing) == 'number' && (bearing >= 0 && bearing <= 360)) {
            // need to calculate rotation
            calculateRotation = true;
        }
        else {
            // need to calculate rotation
            calculateRotation = false;
        }
        if (calculateRotation) {
            // calculate the rotation from the bearing and the initialImage Direction
            rotation = bearing - initialImageDirection;
            // normalise rotation to be between 0 and 360, we need a modulo so we loose the sign of the negative rotations so
            rotation = ((rotation % 360) + 360) % 360;
            if (calculateFlip) {
                // now calculate the flip if we need one
                const wheelRotation = initialImageWheelDirection - rotation;
                if (wheelRotation < 90 || wheelRotation > 270) {
                    isFlip = true;
                }
            }
        }
        return { rotation, isFlip };
    }
    processHandlebarsOnVisualItem(componentDefinition, contextParams, value, field, handlebarsContext, returnType, handlebarsOptions) {
        let result;
        if (field) {
            switch (returnType) {
                case 'int':
                    return sclMapHandlebars.processIntHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'float':
                    return sclMapHandlebars.processFloatHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'boolean':
                    return sclMapHandlebars.processBooleanHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'array':
                    return sclMapHandlebars.processArrayHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                default:
                    return sclMapHandlebars.processHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
            }
        }
        else if (value) {
            switch (returnType) {
                case 'int':
                    return sclMapHandlebars.processIntHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'float':
                    return sclMapHandlebars.processFloatHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'boolean':
                    return sclMapHandlebars.processBooleanHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'array':
                    return sclMapHandlebars.processArrayHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                default:
                    return sclMapHandlebars.processHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
            }
        }
        return result;
    }
    processHandlebarsOnLabel(componentDefinition, contextParams, label, handlebarsContext, layer, layerIndex, idCache) {
        label.labelText = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelText, layer.labelTextHandlebars, handlebarsContext, null, null);
        label.labelColor = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelColor, layer.labelColorHandlebars, handlebarsContext, null, null);
        label.labelOutlineColor = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOutlineColor, layer.labelOutlineColorHandlebars, handlebarsContext, null, null);
        label.labelOutlineWidth = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOutlineWidth, layer.labelOutlineWidthHandlebarsRemoveElastic, handlebarsContext, 'int', null);
        label.labelFont = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelFont, layer.labelFontHandlebars, handlebarsContext, null, null);
        label.labelFontSize = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelFontSize, layer.labelFontSizeHandlebars, handlebarsContext, 'int', null);
        label.labelTextAlign = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelTextAlign, layer.labelTextAlignHandlebars, handlebarsContext, null, null);
        label.labelTextBaseline = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelTextBaseline, layer.labelTextBaselineHandlebars, handlebarsContext, null, null);
        label.labelOffsetX = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOffsetX, layer.labelOffsetXHandlebars, handlebarsContext, 'int', null);
        label.labelOffsetY = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOffsetY, layer.labelOffsetYHandlebars, handlebarsContext, 'int', null);
        label.labelPlacement = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelPlacement, layer.labelPlacementHandlebars, handlebarsContext, null, null);
        label.labelMaxAngle = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelMaxAngle, layer.labelMaxAngleHandlebars, handlebarsContext, 'float', null);
        label.labelOverflow = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOverflow, layer.labelOverflowHandlebars, handlebarsContext, 'boolean', null);
        label.labelRotationWithView = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelRotationWithView, layer.labelRotationWithViewHandlebars, handlebarsContext, 'boolean', null);
        label.labelRotation = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelRotation, layer.labelRotationHandlebars, handlebarsContext, 'int', null);
        label.labelPadding = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelPadding, layer.labelPaddingHandlebars, handlebarsContext, 'array', null);
        label.labelFontWeight = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelFontWeight, layer.labelFontWeightHandlebars, handlebarsContext, null, null);
        label.labelDisplayZoom = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelDisplayZoom, layer.labelDisplayZoomHandlebars, handlebarsContext, 'int', null);
        return label;
    }
    processHandlebarsOnLayer(componentDefinition, contextParams, layerClone, handlebarsContext, layer, layerIndex) {
        layerClone.lineCap = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.lineCap, layer.lineCapHandlebars, handlebarsContext, null, null);
        if (!layerClone.lineCap && layer.lineCap) {
            layerClone.lineCap = layer.lineCap;
        }
        layerClone.lineWidth = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.lineWidth, layer.lineWidthHandlebars, handlebarsContext, 'int', null);
        if (!layerClone.lineWidth && layer.lineWidth) {
            layerClone.lineWidth = layer.lineWidth;
        }
        layerClone.lineDash = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.lineDash, layer.lineDashHandlebars, handlebarsContext, 'array', null);
        if (!layerClone.lineDash && layer.lineDash) {
            layerClone.lineDash = layer.lineDash;
        }
        layerClone.fill = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.fill, layer.fillHandlebars, handlebarsContext, null, null);
        if (!layerClone.fill && layer.fill) {
            layerClone.fill = layer.fill;
        }
        layerClone.fillOpacity = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.fillOpacity, layer.fillOpacityHandlebars, handlebarsContext, 'float', null);
        if (!layerClone.fillOpacity && layer.fillOpacity) {
            layerClone.fillOpacity = layer.fillOpacity;
        }
        return layerClone;
    }
    processHandlebarsOnField(componentDefinition, contextParams, handlebarsContext, layerName, layerIndex, fieldName, layerField, layerFieldHandlebars, returnType) {
        // anchor = this.processHandlebarsOnVisualItem(layer.imageAnchor, layer.imageAnchorHandlebars, handlebarsContext, 'array', {
        //   handlebarsTemplateName: `${layer.name}_${layerIndex}_anchor`
        // });
        // if (!anchor && layer.imageAnchor) { anchor = layer.imageAnchor; }
        const field = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layerField, layerFieldHandlebars, handlebarsContext, returnType, null);
        return field;
    }
    processDynamicLayerData(layer, itemData, i, layerIndex, customData, vehicle) {
        const item = itemData.features[0];
        const pro = item.properties;
        const name = (pro.name ? pro.name : '');
        if (pro.labelDisplayZoom && (typeof pro.labelDisplayZoom === 'string' || pro.labelDisplayZoom instanceof String)) {
            pro.labelDisplayZoom = parseInt(pro.labelDisplayZoom);
        }
        // console.log('***** label = ' + pro.label);
        const label = {
            labelText: (typeof (pro.label) === 'string' && pro.label.trim().length > 0)
                ? pro.label : layer.labelText,
            labelTextAlign: (typeof (pro.labelTextAlign) === 'string' && pro.labelTextAlign.trim().length > 0)
                ? pro.labelTextAlign : layer.labelTextAlign,
            labelTextBaseline: (typeof (pro.labelTextBaseline) === 'string' && pro.labelTextBaseline.trim().length > 0)
                ? pro.labelTextBaseline : layer.labelTextBaseline,
            labelColor: (typeof (pro.labelColor) === 'string' && pro.labelColor.trim().length > 0)
                ? pro.labelColor : layer.labelColor,
            labelOutlineColor: (typeof (pro.labelOutlineColor) === 'string' && pro.labelOutlineColor.trim().length > 0)
                ? pro.labelOutlineColor : layer.labelOutlineColor,
            labelOutlineWidth: (typeof (pro.labelOutlineWidth) === 'number' && pro.labelOutlineWidth > 0)
                ? pro.labelOutlineWidth : layer.labelOutlineWidth,
            labelOffsetX: (typeof (pro.labelOffsetX) === 'number') ? pro.labelOffsetX : layer.labelOffsetX,
            labelOffsetY: (typeof (pro.labelOffsetY) === 'number') ? pro.labelOffsetY : layer.labelOffsetY,
            labelPlacement: (typeof (pro.labelPlacement) === 'string' && pro.labelPlacement.trim().length > 0)
                ? pro.labelPlacement : layer.labelPlacement,
            labelMaxAngle: (typeof (pro.labelMaxAngle) === 'number' && pro.labelMaxAngle >= 0 && pro.labelMaxAngle <= 360)
                ? pro.labelMaxAngle : layer.labelMaxAngle,
            labelOverflow: (typeof (pro.labelOverflow) === 'boolean') ? pro.labelOverflow : layer.labelOverflow,
            labelRotationWithView: (typeof (pro.labelRotationWithView) === 'boolean') ? pro.labelRotationWithView : layer.labelRotationWithView,
            labelRotation: (typeof (pro.labelRotation) === 'number' && pro.labelRotation >= 0 && pro.labelRotation <= 360)
                ? pro.labelRotation : layer.labelRotation,
            labelPadding: (Array.isArray(pro.labelPadding)) ? pro.labelPadding : layer.labelPadding,
            labelFont: (typeof (pro.labelFont) === 'string' && pro.labelFont.trim().length > 0)
                ? pro.labelFont : layer.labelFont,
            labelFontWeight: (typeof (pro.labelFontWeight) === 'string' && pro.labelFontWeight.trim().length > 0)
                ? pro.labelFontWeight : layer.labelFontWeight,
            labelFontSize: (typeof (pro.labelFontSize) === 'string' && pro.labelFontSize.trim().length > 0
                && pro.labelFontSize.indexOf('px') > -1) ? pro.labelFontSize : layer.labelFontSize,
            labelDisplayZoom: (typeof (pro.labelDisplayZoom) === 'number' && pro.labelDisplayZoom > 0)
                ? pro.labelDisplayZoom : layer.labelDisplayZoom
        };
        let imageFileNo = '';
        if (layer.imageFileNo) {
            imageFileNo = layer.imageFileNo;
        }
        if (pro.image && Array.isArray(pro.image) && pro.image.length > 0) {
            imageFileNo = pro.image[0].fileNo;
        }
        const calRotate = this.calculateRotate(pro.bearing, pro.initialImageDirection, pro.initialImageWheelDirection); // (pro.bearing ? pro.bearing: 0);
        const rotation = calRotate.rotation;
        let scaleValue = 1;
        if (typeof (pro.imageScale) == 'number' && pro.imageScale > 0) {
            // need to calculate rotation
            scaleValue = pro.imageScale;
        }
        let scale = [scaleValue, scaleValue];
        if (calRotate.isFlip) {
            scale[0] = -scaleValue;
        }
        // console.log('**** rotation = ' + rotation + ', isFlip = ' + calRotate.isFlip);
        const tooltip = ((typeof (pro.tooltip) === 'string' && pro.tooltip.trim().length > 0) ? pro.tooltip : layer.tooltip);
        const dataId = pro.vehicleDocumentId;
        if (!dataId) {
            console.log(`*** invalid vehicleDocumentId: ${dataId}`);
        }
        const id = dataId + '_' + i + '_' + layerIndex;
        const url = 'form/' + dataId;
        const handlebarsContext = {
            results: customData,
            resultsCount: customData.length,
            resultsIndex: i,
            queryResultDocument: itemData,
        };
        if (vehicle) {
            handlebarsContext.vehicle = vehicle;
        }
        return { pro, handlebarsContext, label, item, id, name, tooltip, imageFileNo, url, dataId, rotation, scale };
    }
    processLayerRotation(layer, layerIndex, componentDefinition, contextParams, handlebarsContext) {
        let rotation = 0;
        if (layer.imageRotation) {
            rotation = layer.imageRotation;
        }
        if (layer.imageRotationHandlebars) {
            rotation = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.imageRotation, layer.imageRotationHandlebars, handlebarsContext, 'int', null);
            if (!rotation && layer.imageRotation) {
                rotation = layer.imageRotation;
            }
            if (!rotation) {
                rotation = 0;
            }
        }
        return rotation;
    }
    checkValidStyleString(obj) {
        if (!isString(obj) || obj.trim().length == 0 || obj.indexOf('{') > -1 || obj.indexOf('}') > -1) {
            return false;
        }
        return true;
    }
    checkStyleValue(assetSelection, isPrimary) {
        const styleInfo = cloneDeep(assetSelection);
        if (!this.checkValidStyleString(assetSelection.selectionImageFileNo)) {
            // console.log('invalid value of selectionImageFileNo: ' + assetSelection.selectionImageFileNo);
            styleInfo.selectionImageFileNo = (isPrimary ? SclMapConstantService.MAP_PRIMARY_ASSET : SclMapConstantService.MAP_SECONDARY_ASSET);
        }
        if (!Array.isArray(assetSelection.selectionImageAnchor)) {
            // console.log('invalid value of selectionImageAnchor: ' + assetSelection.selectionImageAnchor);
            styleInfo.selectionImageAnchor = [0.5, 0.5];
        }
        if (!isNumber(assetSelection.selectionImageRotation)) {
            // console.log('invalid value of selectionImageRotation: ' + assetSelection.selectionImageRotation);
            styleInfo.selectionImageRotation = 0;
        }
        if (!this.checkValidStyleString(assetSelection.selectionColor)) {
            // console.log('invalid value of selectionColor: ' + assetSelection.selectionColor);
            styleInfo.selectionColor = 'purple';
        }
        if (!this.checkValidStyleString(assetSelection.selectionFill)) {
            // console.log('invalid value of selectionFill: ' + assetSelection.selectionFill);
            styleInfo.selectionFill = 'purple';
        }
        if (!isNumber(assetSelection.selectionFillOpacity)) {
            // console.log('invalid value of selectionFillOpacity: ' + assetSelection.selectionFillOpacity);
            styleInfo.selectionFillOpacity = 1;
        }
        if (!this.checkValidStyleString(assetSelection.selectionLineCap)) {
            // console.log('invalid value of selectionColor: ' + assetSelection.selectionColor);
            styleInfo.selectionLineCap = null;
        }
        if (!Array.isArray(assetSelection.selectionLineDash)) {
            styleInfo.selectionLineDash = null;
        }
        if (!isNumber(assetSelection.selectionLineWidth)) {
            // console.log('invalid value of selectionImageRotation: ' + assetSelection.selectionImageRotation);
            styleInfo.selectionLineWidth = null;
        }
        return styleInfo;
    }
    toRadians(angleInDegrees) {
        return (angleInDegrees * Math.PI) / 180;
    }
    toDegrees(angleInRadians) {
        return (angleInRadians * 180) / Math.PI;
    }
    offset(c1, distance, earthRadius, bearing) {
        var lat1 = this.toRadians(c1[1]);
        var lon1 = this.toRadians(c1[0]);
        var dByR = distance / earthRadius;
        var lat = Math.asin(Math.sin(lat1) * Math.cos(dByR) + Math.cos(lat1) * Math.sin(dByR) * Math.cos(bearing));
        var lon = lon1 +
            Math.atan2(Math.sin(bearing) * Math.sin(dByR) * Math.cos(lat1), Math.cos(dByR) - Math.sin(lat1) * Math.sin(lat));
        return [this.toDegrees(lon), this.toDegrees(lat)];
    }
    circleToPolygon(center, radius) {
        var n = 4; // there has 32 segments
        var earthRadius = 6378137;
        var bearing = 0;
        var direction = -1;
        var start = this.toRadians(bearing);
        var coordinates = [];
        for (var i = 0; i < n; ++i) {
            coordinates.push(this.offset(center, radius, earthRadius, start + (direction * 2 * Math.PI * -i) / n));
        }
        coordinates.push(coordinates[0]);
        return [coordinates];
    }
    calculateCircleCenterPoint(p1, p2) {
        const x1 = p1[0];
        const y1 = p1[1];
        const x2 = p2[0];
        const y2 = p2[1];
        const x = (x1 + x2) / 2;
        const y = (y1 + y2) / 2;
        console.log(`center = [${x}, ${y}]`);
        return [x, y];
    }
    buildFilterObj(componentDefinition, geoJsonField) {
        const fil = {
            filter: componentDefinition.filter,
            layerDisplayOnly: componentDefinition.layerDisplayOnly,
            geoJsonField,
        };
        if (componentDefinition.color) {
            fil.color = componentDefinition.color;
        }
        if (componentDefinition.fill) {
            fil.fill = componentDefinition.fill;
        }
        if (componentDefinition.fillOpacity) {
            fil.fillOpacity = componentDefinition.fillOpacity;
        }
        if (componentDefinition.tooltips) {
            fil.tooltips = componentDefinition.tooltips;
        }
        if (componentDefinition.lineDash) {
            fil.lineDash = componentDefinition.lineDash;
        }
        if (componentDefinition.lineCap) {
            fil.lineCap = componentDefinition.lineCap;
        }
        if (componentDefinition.lineWidth) {
            fil.lineWidth = componentDefinition.lineWidth;
        }
        if (componentDefinition.imageAnchor) {
            fil.imageAnchor = componentDefinition.imageAnchor;
        }
        if (componentDefinition.imageFileNo) {
            fil.imageFileNo = componentDefinition.imageFileNo;
        }
        if (componentDefinition.labelText) {
            fil.labelText = componentDefinition.labelText;
        }
        if (componentDefinition.labelTextAlign) {
            fil.labelTextAlign = componentDefinition.labelTextAlign;
        }
        if (componentDefinition.labelTextBaseline) {
            fil.labelTextBaseline = componentDefinition.labelTextBaseline;
        }
        if (componentDefinition.labelColor) {
            fil.labelColor = componentDefinition.labelColor;
        }
        if (componentDefinition.labelOutlineColor) {
            fil.labelOutlineColor = componentDefinition.labelOutlineColor;
        }
        if (componentDefinition.labelOutlineWidth) {
            fil.labelOutlineWidth = componentDefinition.labelOutlineWidth;
        }
        if (componentDefinition.labelOffsetX) {
            fil.labelOffsetX = componentDefinition.labelOffsetX;
        }
        if (componentDefinition.labelOffsetY) {
            fil.labelOffsetY = componentDefinition.labelOffsetY;
        }
        if (componentDefinition.labelPlacement) {
            fil.labelPlacement = componentDefinition.labelPlacement;
        }
        if (componentDefinition.labelMaxAngle) {
            fil.labelMaxAngle = componentDefinition.labelMaxAngle;
        }
        if (componentDefinition.labelOverflow) {
            fil.labelOverflow = componentDefinition.labelOverflow;
        }
        if (componentDefinition.labelRotationWithView) {
            fil.labelRotationWithView = componentDefinition.labelRotationWithView;
        }
        if (componentDefinition.labelRotation) {
            fil.labelRotation = componentDefinition.labelRotation;
        }
        if (componentDefinition.labelPadding) {
            fil.labelPadding = componentDefinition.labelPadding;
        }
        if (componentDefinition.labelFont) {
            fil.labelFont = componentDefinition.labelFont;
        }
        if (componentDefinition.labelFontWeight) {
            fil.labelFontWeight = componentDefinition.labelFontWeight;
        }
        if (componentDefinition.labelFontSize) {
            fil.labelFontSize = componentDefinition.labelFontSize;
        }
        if (componentDefinition.labelDisplayZoom) {
            fil.labelDisplayZoom = componentDefinition.labelDisplayZoom;
        }
        if (componentDefinition.type) {
            fil.type = componentDefinition.type;
        }
        return fil;
    }
}
/** @nocollapse */ /** @nocollapse */ SclUtilMapService.ɵfac = function SclUtilMapService_Factory(t) { return new (t || SclUtilMapService)(); };
/** @nocollapse */ /** @nocollapse */ SclUtilMapService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclUtilMapService, factory: SclUtilMapService.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclUtilMapService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return []; }, null); })();

class AddressDetails {
    constructor() {
        this.properties = {};
        this.geometry = {};
        this.type = 'Feature';
        this.properties = {
            type: 'street',
            unitNo: '',
            streetNo: '',
            street: '',
            suburb: '',
            postcode: '',
            locationDescription: '',
            country: '',
            iconImage: '',
            iconSize: '',
            state: ''
        };
        this.geometry = {
            type: 'Point',
            coordinates: []
        };
    }
}

const sclUtilMapService$1 = new SclUtilMapService();
const googleMapLoaderService = new GoogleMapLoaderService();
class SclMapGeoGoogleService {
    constructor() {
        this.autocompleteUrl = 'https://maps.googleapis.com/maps/api/place/autocomplete/json?input=';
        this.geocodeUrl = 'https://maps.googleapis.com/maps/api/geocode/json?latlng=';
        this.googleLoader = null;
        this.waitTime = 5000; // miliseconds
        this.loadLookup = false;
        this.intervalSetupLookUpCount = 0;
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        if (!this.apiKeyReverse) {
            this.apiKeyReverse = this.apiKey;
        }
        if (!this.apiKeyReverse) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('apiKey null');
            }
            return;
        }
        let link = this.geocodeUrl + coor[1] + ',' + coor[0] + '&key=' + this.apiKeyReverse;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data.status === 'OK') {
                const datas = data.results[0];
                let streetData = new AddressDetails();
                streetData = sclUtilMapService$1.fillGoogleAddress(datas, streetData);
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: datas.geometry.location.lat, lng: datas.geometry.location.lng });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    let errorMsg = 'Google reverse Error';
                    if (data !== null && data.error_message !== null) {
                        errorMsg = data.error_message;
                    }
                    cbErr(errorMsg);
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Google reverse Error');
                }
            }
        });
    }
    setupLookUp() {
        const apiKey = this.apiKey;
        googleMapLoaderService.KEY = apiKey;
        googleMapLoaderService.LIBRARIES = 'places,drawing,visualization';
        googleMapLoaderService.SENSOR = true;
        if (this.intervalSetupLookUp) {
            return;
        }
        this.intervalSetupLookUp = setInterval(() => {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
            if (this.autocompleteStreet) {
                clearInterval(this.intervalSetupLookUp);
                this.intervalSetupLookUp = null;
                this.intervalSetupLookUpCount = 0; // reset
                // console.log('find autocompletebox');
                googleMapLoaderService.load().then((google) => {
                    const autocompleteObj = new google.maps.places.Autocomplete(this.autocompleteStreet, { types: ['geocode'] });
                    google.maps.event.addListener(autocompleteObj, 'place_changed', () => {
                        const place = autocompleteObj.getPlace();
                        let streetData = new AddressDetails();
                        streetData = sclUtilMapService$1.fillGoogleAddress(place, streetData);
                        if (this.cbSelectOption && typeof this.cbSelectOption === 'function') {
                            this.cbSelectOption(streetData);
                        }
                    });
                });
            }
            else {
                this.intervalSetupLookUpCount++;
                if (this.intervalSetupLookUpCount > 11) {
                    console.log('can\'t load google geo service because can\'t find autocomplete box');
                    clearInterval(this.intervalSetupLookUp);
                    this.intervalSetupLookUp = null;
                    this.intervalSetupLookUpCount = 0; // reset
                }
                else {
                    console.log('waiting for autocomplete box loading..');
                }
            }
        }, 100);
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params invalid. [0] : autocompleteBox');
            }
            return;
        }
        if (this.apiKey == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('apiKey is null');
            }
            return;
        }
        if (this.googleLoader === null) {
            this.autocompleteBox = params[0];
            if (!this.loadLookup) {
                this.loadLookup = true;
                this.cbSelectOption = cbSelectOption;
                this.setupLookUp();
            }
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoGoogle';
        const lst = document.querySelectorAll('#' + id);
        if (lst && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].remove();
            }
        }
        this.autocompleteBox = null;
        this.googleLoader = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    getLinkOptions(link) {
        if (this.country) {
            link += '&country=' + this.country;
        }
        if (this.language) {
            link += '&lang=' + this.language;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoGoogleService.ɵfac = function SclMapGeoGoogleService_Factory(t) { return new (t || SclMapGeoGoogleService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoGoogleService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoGoogleService, factory: SclMapGeoGoogleService.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoGoogleService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return []; }, null); })();

class SclMapGeoCodeFarmService {
    constructor() {
        this.autocompleteUrl = 'https://www.geocode.farm/v3/json/forward/?addr=';
        this.geocodeUrl = 'https://www.geocode.farm/v3/json/reverse/';
        this.apiKey = 'a2338e05-e3cb425e93ad-109049bfb516';
        this.apiKeyReverse = 'a2338e05-e3cb425e93ad-109049bfb516';
        this.waitTime = 5000; // miliseconds
        this.preText = '';
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        let link = this.geocodeUrl + '?lat=' + coor[1] + '&lon=' + coor[0] + '&key=' + this.apiKeyReverse + '&count=1';
        link = this.getLinkOptions(link);
        // logger.info("Codefarm reverse , link = " + link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            // let data = results.data;
            if (data && data.geocoding_results.STATUS.status === 'SUCCESS') {
                const suggestions = data.geocoding_results.RESULTS[0];
                const address = suggestions.ADDRESS;
                const streetData = new AddressDetails();
                streetData.properties.streetNo = address.street_number;
                streetData.properties.street = address.street_name;
                streetData.properties.suburb = address.locality;
                streetData.properties.postcode = address.postal_code;
                streetData.properties.country = address.country;
                streetData.properties.state = address.admin_1;
                streetData.geometry.coordinates[0] = coor[0]; // lon
                streetData.geometry.coordinates[1] = coor[1]; // lat
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: parseFloat(suggestions.COORDINATES.latitude), lng: parseFloat(suggestions.COORDINATES.longitude) });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm reverse Error');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm reverse Error');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoCodFarm';
        const lst = document.querySelectorAll('#' + id);
        if (lst && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].remove();
            }
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById('#' + this.initObj.keyName + 'autocomplete');
            // angular.element(element).find('#' + scope.fieldName +'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (this.apiKey == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('apiKey is null');
            }
            return;
        }
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('text is null');
            }
            return;
        }
        const results = [];
        const newText = sPartialAddress.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb([]);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('text is less than 3 words');
            }
            return;
        }
        // if(scope.geocoderDefaultState) sPartialAddress += ", " + scope.geocoderDefaultState;
        // if(scope.geocoderDefaultCountry) sPartialAddress += ", " + scope.geocoderDefaultCountry;
        // sPartialAddress += ", VIC, Australia";
        sPartialAddress += '&country=au&lang=en';
        let link = this.autocompleteUrl + sPartialAddress + '&key=' + this.apiKey;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe((data) => {
            if (data && data.geocoding_results && data.geocoding_results.STATUS.status === 'SUCCESS') {
                const suggestions = data.geocoding_results.RESULTS;
                for (let i = 0; i < suggestions.length; i++) {
                    const predict = suggestions[i];
                    const sugg = {};
                    sugg.street = predict.formatted_address;
                    sugg.address = predict.ADDRESS;
                    sugg.coordinates = predict.COORDINATES;
                    results.push(sugg);
                }
                if (cb && typeof cb === 'function') {
                    cb(results);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm lookup Error ');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm lookup Error ');
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const address = tpl.address;
        const coordinates = tpl.coordinates;
        const obj = new AddressDetails();
        if (address.unitNo) {
            obj.properties.unitNo = address.unitNo;
        }
        obj.properties.streetNo = address.street_number;
        obj.properties.street = address.street_name;
        obj.properties.suburb = address.locality;
        obj.properties.postcode = address.postal_code;
        obj.properties.country = address.country;
        obj.properties.state = address.admin_1;
        const lat = parseFloat(coordinates.latitude);
        const lon = parseFloat(coordinates.longitude);
        obj.geometry.coordinates[0] = lon;
        obj.geometry.coordinates[1] = lat;
        if (cb && typeof cb === 'function') {
            cb(obj);
        }
    }
    getLinkOptions(link) {
        if (this.country) {
            link += '&country=' + this.country;
        }
        if (this.language) {
            link += '&lang=' + this.language;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoCodeFarmService.ɵfac = function SclMapGeoCodeFarmService_Factory(t) { return new (t || SclMapGeoCodeFarmService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoCodeFarmService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoCodeFarmService, factory: SclMapGeoCodeFarmService.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoCodeFarmService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return []; }, null); })();

const sclMapConstant$4 = SclMapConstantService;
class SclMapGeoHereService {
    constructor() {
        this.autocompleteUrl = 'https://geocoder.api.here.com/6.2/geocode.json';
        this.geocodeUrl = 'https://reverse.geocoder.api.here.com/6.2/reversegeocode.json';
        this.appId = 'UFP3Mq8ODsPalgiBwWVS';
        this.appCode = '8bZacaYx2CxDy1PUV3sN2w'; // appcode
        this.waitTime = 5000; // miliseconds
        this.radius = 50;
        this.preText = '';
        this.hasPrimaryAssetAddressLookup = false;
    }
    setSuburb(address) {
        const gotDistrict = address.Label.indexOf(address.District);
        const gotCity = address.Label.indexOf(address.City);
        if (gotDistrict >= 0 && gotCity >= 0) {
            if (gotDistrict < gotCity) {
                return address.City;
            }
            else {
                return address.District;
            }
        }
        else if (gotDistrict < 0) {
            return address.City;
        }
        else {
            return address.District;
        }
    }
    setupReverse(geo) {
        if (geo.radius) {
            this.radius = geo.radius;
        }
        if (geo.primaryAssetAddressLookupRadius) {
            this.primaryAssetAddressLookupRadius = geo.primaryAssetAddressLookupRadius;
        }
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        const lat = coor[1];
        const lon = coor[0];
        let radius = coor[2];
        if (this.hasPrimaryAssetAddressLookup === true) {
            radius = this.primaryAssetAddressLookupRadius;
        }
        else {
            radius = this.radius;
        }
        let link = this.geocodeUrl + '?app_id=' + this.appId + '&app_code=' + this.appCode
            + '&prox=' + lat + ',' + lon + ',' + radius + '&mode=retrieveAddresses&maxresults=1&gen=9';
        link = this.getLinkOptions(link);
        //// logger.info("HERE reverse , link = " + link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data && data.Response && data.Response.View && data.Response.View.length > 0
                && data.Response.View[0].Result && data.Response.View[0].Result.length > 0) {
                const suggestions = data.Response.View[0].Result[0];
                const address = suggestions.Location.Address;
                const streetData = new AddressDetails();
                streetData.properties.streetNo = address.HouseNumber;
                streetData.properties.street = address.Street;
                streetData.properties.suburb = this.setSuburb(address);
                streetData.properties.postcode = address.PostalCode;
                streetData.properties.country = address.Country;
                streetData.properties.state = address.State;
                streetData.geometry.coordinates[0] = lon; // lon
                streetData.geometry.coordinates[1] = lat; // lat
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: suggestions.Location.DisplayPosition.Latitude,
                        lng: suggestions.Location.DisplayPosition.Longitude });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com reverse address lookup Error');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com reverse address lookup Error');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoHere';
        const elem = document.getElementById(id);
        if (elem) {
            elem.remove();
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (!this.appId) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: appId is null');
            }
            return;
        }
        if (!this.appCode) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: appCode is null');
            }
            return;
        }
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: text is null');
            }
            return;
        }
        const results = [];
        const newText = sPartialAddress.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb([]);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: text is less than 3 characters');
            }
            return;
        }
        let link = this.autocompleteUrl + '?app_id=' + this.appId + '&app_code=' + this.appCode + '&searchtext=' + sPartialAddress;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data && data.Response && data.Response.View && data.Response.View.length > 0) {
                const suggestions = data.Response.View[0].Result;
                for (let i = 0; i < suggestions.length; i++) {
                    const predict = suggestions[i];
                    const sugg = {};
                    sugg.street = predict.Location.Address.Label;
                    sugg.address = predict.Location.Address;
                    sugg.coordinates = predict.Location.DisplayPosition;
                    results.push(sugg);
                }
                //// logger.info('result = ' + JSON.stringify(results));
                if (cb && typeof cb === 'function') {
                    cb(results);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com address lookup Error ');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com address lookup Error ');
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const address = tpl.address;
        const coordinates = tpl.coordinates;
        const obj = new AddressDetails();
        obj.properties.streetNo = address.HouseNumber;
        obj.properties.street = address.Street;
        obj.properties.suburb = this.setSuburb(address);
        obj.properties.postcode = address.PostalCode;
        obj.properties.country = address.Country;
        obj.properties.state = address.State;
        const lat = parseFloat(coordinates.Latitude);
        const lon = parseFloat(coordinates.Longitude);
        obj.geometry.coordinates[0] = lon;
        obj.geometry.coordinates[1] = lat;
        if (cb && typeof cb === 'function') {
            cb(obj);
        }
    }
    getLinkOptions(link) {
        if (this.state) {
            link += ' ' + this.state;
        }
        if (this.country) {
            link += ' ' + this.country;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoHereService.ɵfac = function SclMapGeoHereService_Factory(t) { return new (t || SclMapGeoHereService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoHereService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoHereService, factory: SclMapGeoHereService.ɵfac, providedIn: 'root' });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoHereService, [{
        type: Injectable,
        args: [{
                providedIn: 'root'
            }]
    }], function () { return []; }, null); })();

const sclMapConstant$3 = SclMapConstantService;
class SclMapGeoPSMAService {
    constructor(formbirdInjectorService) {
        this.formbirdInjectorService = formbirdInjectorService;
        this.autocompleteUrl = 'https://api.psma.com.au/v1/predictive/address?query=';
        this.addressUrl = 'https://api.psma.com.au/v1/predictive/address/';
        this.geocodeUrl = 'https://api.psma.com.au/v1/addresses?radius=';
        this.geocodeUrlNext = 'https://api.psma.com.au/v1/addresses/'; // GAVIC419864439/geo/
        this.apiKeyReverse = 'z1mhEpstfwLdqzVTBAX1dkR5iVy6LaLq'; // "7hLa5GrKDVM5alRX1mGLm8xGmbz3JyKA"; --> old key
        this.waitTime = 5000; // miliseconds
        this.reverseNoAddressIncrement = 0;
        this.reverseNoAddressRetry = 0;
        this.enableReverseRadiusDisplay = false;
        this.showReverseAddressPoint = 0;
        this.psmaRadius = 50;
        this.psmaHasStreetData = false;
        this.psmaAddressData = [];
        this.psmaAddressDetailUrl = '';
        this.dropPinSelectsAddres = false;
        this.reverseAddress = [];
        this.psmaPoints = [];
        this.psmaFinalRadius = 0;
        this.psmaOutOfRadius = [];
        this.psmaIndexAddress = -1;
        this.psmaCountGetGPS = 0;
        this.isFeatureRemoving = false; // use to stop reverse service get address
        this.page = 1;
        this.callLookUp = false;
        this.preText = '';
        this.hasPrimaryAssetAddressLookup = false;
        this.notificationService = this.formbirdInjectorService.get('NotificationService');
    }
    setupReverse(geo) {
        if (geo.reverseNoAddressIncrement) {
            this.reverseNoAddressIncrement = geo.reverseNoAddressIncrement;
        }
        if (geo.reverseNoAddressRetry) {
            this.reverseNoAddressRetry = (geo.reverseNoAddressRetry <= 0 ? 1 : (geo.reverseNoAddressRetry + 1));
        }
        if (geo.enableReverseRadiusDisplay) {
            this.enableReverseRadiusDisplay = geo.enableReverseRadiusDisplay;
        }
        if (geo.showReverseAddressPoint) {
            this.showReverseAddressPoint = geo.showReverseAddressPoint;
        }
        if (geo.radius) {
            this.psmaRadius = geo.radius;
   